> ## Documentation Index
> Fetch the complete documentation index at: https://docs.interchange.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Discover signals

> Query signal agents via AdCP to discover available signals. Does not persist results.



## OpenAPI

````yaml /v2/storefront-api-v2.yaml post /signals/discover
openapi: 3.0.0
info:
  title: Scope3 Storefront API
  version: 2.0.0
  description: |-
    REST API for partners to manage storefronts, inventory sources, and billing.

    ## Authentication

    All endpoints require a Bearer token in the Authorization header:
    ```
    Authorization: Bearer your-api-key
    ```

    ## Base URL

    `https://api.interchange.io/api/v2/storefront`

    ## For AI Agents

    AI agents can use the MCP endpoint at `/mcp/v2/storefront` with three tools:
    - `initialize`: Start an MCP session
    - `api_call`: Make REST API calls
    - `ask_about_capability`: Learn about API features
servers:
  - url: https://api.interchange.io/api/v2/storefront
    description: Production server
security: []
tags:
  - name: Account
    description: Account management, service tokens, and preferences
  - name: Asks
    description: >-
      What you are waiting on Scope3 for — support, product, and supply asks in
      one list
  - name: Storefront
    description: Manage storefront and inventory sources
  - name: Storefront Agents
    description: List and manage registered sales, signals, and outcomes agents
  - name: Storefront Activity
    description: Audit log of configuration and inventory changes on the storefront
  - name: Storefront Billing
    description: Payout bank details and billing configuration for storefronts
  - name: AI Usage
    description: Storefront AI token usage visibility by model
  - name: MCP
    description: Model Context Protocol endpoints
paths:
  /signals/discover:
    post:
      tags:
        - Signals
      summary: Discover signals
      description: >-
        Query signal agents via AdCP to discover available signals. Does not
        persist results.
      operationId: discoverSignals
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/DiscoverSignalsInput'
      responses:
        '200':
          description: Discover signals
          content:
            application/json:
              schema:
                type: object
                properties:
                  agentResults:
                    type: array
                    items:
                      type: object
                      properties:
                        agentId:
                          type: string
                        agentName:
                          type: string
                        success:
                          type: boolean
                        signalCount:
                          type: integer
                          minimum: -9007199254740991
                          maximum: 9007199254740991
                        error:
                          type: string
                      required:
                        - agentId
                        - agentName
                        - success
                        - signalCount
                      additionalProperties: false
                  signals:
                    type: array
                    items:
                      type: object
                      properties:
                        signalId:
                          type: string
                        name:
                          type: string
                        description:
                          type: string
                        dataProvider:
                          type: string
                        coveragePercentage:
                          nullable: true
                          type: number
                        access:
                          type: array
                          items:
                            type: object
                            properties:
                              advertiserId:
                                nullable: true
                                type: integer
                                format: int64
                              visibility:
                                type: string
                              price:
                                nullable: true
                                anyOf:
                                  - type: object
                                    properties:
                                      pricing_option_id:
                                        type: string
                                      pricing_model:
                                        type: string
                                        enum:
                                          - cpm
                                      currency:
                                        type: string
                                        pattern: ^[A-Z]{3}$
                                      fixed_price:
                                        type: number
                                        minimum: 0
                                      floor_price:
                                        type: number
                                        minimum: 0
                                      max_bid:
                                        type: boolean
                                      price_guidance:
                                        type: object
                                        properties:
                                          p25:
                                            type: number
                                            minimum: 0
                                          p50:
                                            type: number
                                            minimum: 0
                                          p75:
                                            type: number
                                            minimum: 0
                                          p90:
                                            type: number
                                            minimum: 0
                                        additionalProperties: {}
                                      min_spend_per_package:
                                        type: number
                                        minimum: 0
                                      price_breakdown:
                                        type: object
                                        properties:
                                          list_price:
                                            type: number
                                          adjustments:
                                            type: array
                                            items:
                                              type: object
                                              additionalProperties: {}
                                        required:
                                          - list_price
                                          - adjustments
                                        additionalProperties: {}
                                      eligible_adjustments:
                                        type: array
                                        items:
                                          anyOf:
                                            - type: string
                                              enum:
                                                - fee
                                            - type: string
                                              enum:
                                                - discount
                                            - type: string
                                              enum:
                                                - commission
                                            - type: string
                                              enum:
                                                - settlement
                                    required:
                                      - pricing_option_id
                                      - pricing_model
                                      - currency
                                    additionalProperties: {}
                                  - type: object
                                    properties:
                                      pricing_option_id:
                                        type: string
                                      pricing_model:
                                        type: string
                                        enum:
                                          - vcpm
                                      currency:
                                        type: string
                                        pattern: ^[A-Z]{3}$
                                      fixed_price:
                                        type: number
                                        minimum: 0
                                      floor_price:
                                        type: number
                                        minimum: 0
                                      max_bid:
                                        type: boolean
                                      price_guidance:
                                        type: object
                                        properties:
                                          p25:
                                            type: number
                                            minimum: 0
                                          p50:
                                            type: number
                                            minimum: 0
                                          p75:
                                            type: number
                                            minimum: 0
                                          p90:
                                            type: number
                                            minimum: 0
                                        additionalProperties: {}
                                      min_spend_per_package:
                                        type: number
                                        minimum: 0
                                      price_breakdown:
                                        type: object
                                        properties:
                                          list_price:
                                            type: number
                                          adjustments:
                                            type: array
                                            items:
                                              type: object
                                              additionalProperties: {}
                                        required:
                                          - list_price
                                          - adjustments
                                        additionalProperties: {}
                                      eligible_adjustments:
                                        type: array
                                        items:
                                          anyOf:
                                            - type: string
                                              enum:
                                                - fee
                                            - type: string
                                              enum:
                                                - discount
                                            - type: string
                                              enum:
                                                - commission
                                            - type: string
                                              enum:
                                                - settlement
                                    required:
                                      - pricing_option_id
                                      - pricing_model
                                      - currency
                                    additionalProperties: {}
                                  - type: object
                                    properties:
                                      pricing_option_id:
                                        type: string
                                      pricing_model:
                                        type: string
                                        enum:
                                          - cpc
                                      currency:
                                        type: string
                                        pattern: ^[A-Z]{3}$
                                      fixed_price:
                                        type: number
                                        minimum: 0
                                      floor_price:
                                        type: number
                                        minimum: 0
                                      max_bid:
                                        type: boolean
                                      price_guidance:
                                        type: object
                                        properties:
                                          p25:
                                            type: number
                                            minimum: 0
                                          p50:
                                            type: number
                                            minimum: 0
                                          p75:
                                            type: number
                                            minimum: 0
                                          p90:
                                            type: number
                                            minimum: 0
                                        additionalProperties: {}
                                      min_spend_per_package:
                                        type: number
                                        minimum: 0
                                      price_breakdown:
                                        type: object
                                        properties:
                                          list_price:
                                            type: number
                                          adjustments:
                                            type: array
                                            items:
                                              type: object
                                              additionalProperties: {}
                                        required:
                                          - list_price
                                          - adjustments
                                        additionalProperties: {}
                                      eligible_adjustments:
                                        type: array
                                        items:
                                          anyOf:
                                            - type: string
                                              enum:
                                                - fee
                                            - type: string
                                              enum:
                                                - discount
                                            - type: string
                                              enum:
                                                - commission
                                            - type: string
                                              enum:
                                                - settlement
                                    required:
                                      - pricing_option_id
                                      - pricing_model
                                      - currency
                                    additionalProperties: {}
                                  - type: object
                                    properties:
                                      pricing_option_id:
                                        type: string
                                      pricing_model:
                                        type: string
                                        enum:
                                          - cpcv
                                      currency:
                                        type: string
                                        pattern: ^[A-Z]{3}$
                                      fixed_price:
                                        type: number
                                        minimum: 0
                                      floor_price:
                                        type: number
                                        minimum: 0
                                      max_bid:
                                        type: boolean
                                      price_guidance:
                                        type: object
                                        properties:
                                          p25:
                                            type: number
                                            minimum: 0
                                          p50:
                                            type: number
                                            minimum: 0
                                          p75:
                                            type: number
                                            minimum: 0
                                          p90:
                                            type: number
                                            minimum: 0
                                        additionalProperties: {}
                                      min_spend_per_package:
                                        type: number
                                        minimum: 0
                                      price_breakdown:
                                        type: object
                                        properties:
                                          list_price:
                                            type: number
                                          adjustments:
                                            type: array
                                            items:
                                              type: object
                                              additionalProperties: {}
                                        required:
                                          - list_price
                                          - adjustments
                                        additionalProperties: {}
                                      eligible_adjustments:
                                        type: array
                                        items:
                                          anyOf:
                                            - type: string
                                              enum:
                                                - fee
                                            - type: string
                                              enum:
                                                - discount
                                            - type: string
                                              enum:
                                                - commission
                                            - type: string
                                              enum:
                                                - settlement
                                    required:
                                      - pricing_option_id
                                      - pricing_model
                                      - currency
                                    additionalProperties: {}
                                  - type: object
                                    properties:
                                      pricing_option_id:
                                        type: string
                                      pricing_model:
                                        type: string
                                        enum:
                                          - cpv
                                      currency:
                                        type: string
                                        pattern: ^[A-Z]{3}$
                                      fixed_price:
                                        type: number
                                        minimum: 0
                                      floor_price:
                                        type: number
                                        minimum: 0
                                      max_bid:
                                        type: boolean
                                      price_guidance:
                                        type: object
                                        properties:
                                          p25:
                                            type: number
                                            minimum: 0
                                          p50:
                                            type: number
                                            minimum: 0
                                          p75:
                                            type: number
                                            minimum: 0
                                          p90:
                                            type: number
                                            minimum: 0
                                        additionalProperties: {}
                                      parameters:
                                        type: object
                                        properties:
                                          view_threshold:
                                            anyOf:
                                              - type: number
                                              - type: object
                                                properties:
                                                  duration_seconds:
                                                    type: number
                                                    minimum: 1
                                                required:
                                                  - duration_seconds
                                                additionalProperties: {}
                                        required:
                                          - view_threshold
                                        additionalProperties: {}
                                      min_spend_per_package:
                                        type: number
                                        minimum: 0
                                      price_breakdown:
                                        type: object
                                        properties:
                                          list_price:
                                            type: number
                                          adjustments:
                                            type: array
                                            items:
                                              type: object
                                              additionalProperties: {}
                                        required:
                                          - list_price
                                          - adjustments
                                        additionalProperties: {}
                                      eligible_adjustments:
                                        type: array
                                        items:
                                          anyOf:
                                            - type: string
                                              enum:
                                                - fee
                                            - type: string
                                              enum:
                                                - discount
                                            - type: string
                                              enum:
                                                - commission
                                            - type: string
                                              enum:
                                                - settlement
                                    required:
                                      - pricing_option_id
                                      - pricing_model
                                      - currency
                                      - parameters
                                    additionalProperties: {}
                                  - type: object
                                    properties:
                                      pricing_option_id:
                                        type: string
                                      pricing_model:
                                        type: string
                                        enum:
                                          - cpp
                                      currency:
                                        type: string
                                        pattern: ^[A-Z]{3}$
                                      fixed_price:
                                        type: number
                                        minimum: 0
                                      floor_price:
                                        type: number
                                        minimum: 0
                                      price_guidance:
                                        type: object
                                        properties:
                                          p25:
                                            type: number
                                            minimum: 0
                                          p50:
                                            type: number
                                            minimum: 0
                                          p75:
                                            type: number
                                            minimum: 0
                                          p90:
                                            type: number
                                            minimum: 0
                                        additionalProperties: {}
                                      parameters:
                                        type: object
                                        properties:
                                          demographic_system:
                                            anyOf:
                                              - type: string
                                                enum:
                                                  - nielsen
                                              - type: string
                                                enum:
                                                  - barb
                                              - type: string
                                                enum:
                                                  - agf
                                              - type: string
                                                enum:
                                                  - oztam
                                              - type: string
                                                enum:
                                                  - mediametrie
                                              - type: string
                                                enum:
                                                  - custom
                                          demographic:
                                            type: string
                                          min_points:
                                            type: number
                                            minimum: 0
                                        required:
                                          - demographic
                                        additionalProperties: {}
                                      min_spend_per_package:
                                        type: number
                                        minimum: 0
                                      price_breakdown:
                                        type: object
                                        properties:
                                          list_price:
                                            type: number
                                          adjustments:
                                            type: array
                                            items:
                                              type: object
                                              additionalProperties: {}
                                        required:
                                          - list_price
                                          - adjustments
                                        additionalProperties: {}
                                      eligible_adjustments:
                                        type: array
                                        items:
                                          anyOf:
                                            - type: string
                                              enum:
                                                - fee
                                            - type: string
                                              enum:
                                                - discount
                                            - type: string
                                              enum:
                                                - commission
                                            - type: string
                                              enum:
                                                - settlement
                                    required:
                                      - pricing_option_id
                                      - pricing_model
                                      - currency
                                      - parameters
                                    additionalProperties: {}
                                  - type: object
                                    properties:
                                      pricing_option_id:
                                        type: string
                                      pricing_model:
                                        type: string
                                        enum:
                                          - cpa
                                      event_type:
                                        anyOf:
                                          - type: string
                                            enum:
                                              - page_view
                                          - type: string
                                            enum:
                                              - view_content
                                          - type: string
                                            enum:
                                              - select_content
                                          - type: string
                                            enum:
                                              - select_item
                                          - type: string
                                            enum:
                                              - search
                                          - type: string
                                            enum:
                                              - share
                                          - type: string
                                            enum:
                                              - add_to_cart
                                          - type: string
                                            enum:
                                              - remove_from_cart
                                          - type: string
                                            enum:
                                              - viewed_cart
                                          - type: string
                                            enum:
                                              - add_to_wishlist
                                          - type: string
                                            enum:
                                              - initiate_checkout
                                          - type: string
                                            enum:
                                              - add_payment_info
                                          - type: string
                                            enum:
                                              - purchase
                                          - type: string
                                            enum:
                                              - refund
                                          - type: string
                                            enum:
                                              - lead
                                          - type: string
                                            enum:
                                              - qualify_lead
                                          - type: string
                                            enum:
                                              - close_convert_lead
                                          - type: string
                                            enum:
                                              - disqualify_lead
                                          - type: string
                                            enum:
                                              - complete_registration
                                          - type: string
                                            enum:
                                              - subscribe
                                          - type: string
                                            enum:
                                              - follow
                                          - type: string
                                            enum:
                                              - content_view
                                          - type: string
                                            enum:
                                              - watch_milestone
                                          - type: string
                                            enum:
                                              - start_trial
                                          - type: string
                                            enum:
                                              - app_install
                                          - type: string
                                            enum:
                                              - app_launch
                                          - type: string
                                            enum:
                                              - contact
                                          - type: string
                                            enum:
                                              - schedule
                                          - type: string
                                            enum:
                                              - donate
                                          - type: string
                                            enum:
                                              - submit_application
                                          - type: string
                                            enum:
                                              - custom
                                      custom_event_name:
                                        type: string
                                      event_source_id:
                                        type: string
                                      currency:
                                        type: string
                                        pattern: ^[A-Z]{3}$
                                      fixed_price:
                                        type: number
                                      min_spend_per_package:
                                        type: number
                                        minimum: 0
                                      price_breakdown:
                                        type: object
                                        properties:
                                          list_price:
                                            type: number
                                          adjustments:
                                            type: array
                                            items:
                                              type: object
                                              additionalProperties: {}
                                        required:
                                          - list_price
                                          - adjustments
                                        additionalProperties: {}
                                      eligible_adjustments:
                                        type: array
                                        items:
                                          anyOf:
                                            - type: string
                                              enum:
                                                - fee
                                            - type: string
                                              enum:
                                                - discount
                                            - type: string
                                              enum:
                                                - commission
                                            - type: string
                                              enum:
                                                - settlement
                                    required:
                                      - pricing_option_id
                                      - pricing_model
                                      - event_type
                                      - currency
                                      - fixed_price
                                    additionalProperties: {}
                                  - type: object
                                    properties:
                                      pricing_option_id:
                                        type: string
                                      pricing_model:
                                        type: string
                                        enum:
                                          - flat_rate
                                      currency:
                                        type: string
                                        pattern: ^[A-Z]{3}$
                                      fixed_price:
                                        type: number
                                        minimum: 0
                                      floor_price:
                                        type: number
                                        minimum: 0
                                      price_guidance:
                                        type: object
                                        properties:
                                          p25:
                                            type: number
                                            minimum: 0
                                          p50:
                                            type: number
                                            minimum: 0
                                          p75:
                                            type: number
                                            minimum: 0
                                          p90:
                                            type: number
                                            minimum: 0
                                        additionalProperties: {}
                                      parameters:
                                        type: object
                                        properties:
                                          type:
                                            type: string
                                            enum:
                                              - dooh
                                          sov_percentage:
                                            type: number
                                            minimum: 0
                                            maximum: 100
                                          loop_duration_seconds:
                                            type: number
                                            minimum: 1
                                          min_plays_per_hour:
                                            type: number
                                            minimum: 1
                                          venue_package:
                                            type: string
                                          duration_hours:
                                            type: number
                                            minimum: 0
                                          daypart:
                                            type: string
                                          estimated_impressions:
                                            type: number
                                            minimum: 0
                                        required:
                                          - type
                                        additionalProperties: {}
                                      min_spend_per_package:
                                        type: number
                                        minimum: 0
                                      price_breakdown:
                                        type: object
                                        properties:
                                          list_price:
                                            type: number
                                          adjustments:
                                            type: array
                                            items:
                                              type: object
                                              additionalProperties: {}
                                        required:
                                          - list_price
                                          - adjustments
                                        additionalProperties: {}
                                      eligible_adjustments:
                                        type: array
                                        items:
                                          anyOf:
                                            - type: string
                                              enum:
                                                - fee
                                            - type: string
                                              enum:
                                                - discount
                                            - type: string
                                              enum:
                                                - commission
                                            - type: string
                                              enum:
                                                - settlement
                                    required:
                                      - pricing_option_id
                                      - pricing_model
                                      - currency
                                    additionalProperties: {}
                                  - type: object
                                    properties:
                                      pricing_option_id:
                                        type: string
                                      pricing_model:
                                        type: string
                                        enum:
                                          - time
                                      currency:
                                        type: string
                                        pattern: ^[A-Z]{3}$
                                      fixed_price:
                                        type: number
                                        minimum: 0
                                      floor_price:
                                        type: number
                                        minimum: 0
                                      price_guidance:
                                        type: object
                                        properties:
                                          p25:
                                            type: number
                                            minimum: 0
                                          p50:
                                            type: number
                                            minimum: 0
                                          p75:
                                            type: number
                                            minimum: 0
                                          p90:
                                            type: number
                                            minimum: 0
                                        additionalProperties: {}
                                      parameters:
                                        type: object
                                        properties:
                                          time_unit:
                                            anyOf:
                                              - type: string
                                                enum:
                                                  - hour
                                              - type: string
                                                enum:
                                                  - day
                                              - type: string
                                                enum:
                                                  - week
                                              - type: string
                                                enum:
                                                  - month
                                          min_duration:
                                            type: number
                                            minimum: 1
                                          max_duration:
                                            type: number
                                            minimum: 1
                                        required:
                                          - time_unit
                                        additionalProperties: {}
                                      min_spend_per_package:
                                        type: number
                                        minimum: 0
                                      price_breakdown:
                                        type: object
                                        properties:
                                          list_price:
                                            type: number
                                          adjustments:
                                            type: array
                                            items:
                                              type: object
                                              additionalProperties: {}
                                        required:
                                          - list_price
                                          - adjustments
                                        additionalProperties: {}
                                      eligible_adjustments:
                                        type: array
                                        items:
                                          anyOf:
                                            - type: string
                                              enum:
                                                - fee
                                            - type: string
                                              enum:
                                                - discount
                                            - type: string
                                              enum:
                                                - commission
                                            - type: string
                                              enum:
                                                - settlement
                                    required:
                                      - pricing_option_id
                                      - pricing_model
                                      - currency
                                      - parameters
                                    additionalProperties: {}
                            required:
                              - advertiserId
                              - visibility
                              - price
                            additionalProperties: false
                        regions:
                          nullable: true
                          type: array
                          items:
                            type: string
                            enum:
                              - NORAM
                              - LATAM
                              - EMEA
                              - APAC
                              - ANZ
                              - GLOBAL
                        keyType:
                          nullable: true
                          type: array
                          items:
                            type: string
                            enum:
                              - country
                              - region
                              - metro
                              - topic
                              - eidr
                              - gracenote
                              - isrc
                              - gtin
                              - rss_guid
                              - isbn
                              - url
                              - url_hash
                              - custom
                              - maid
                              - rampid
                              - rampid_derived
                              - hashed_email
                              - hashed_phone
                              - id5
                              - uid2
                              - euid
                              - pairid
                        metadata:
                          nullable: true
                          type: object
                          additionalProperties: {}
                      required:
                        - signalId
                        - name
                        - description
                        - dataProvider
                        - coveragePercentage
                        - access
                        - regions
                        - keyType
                        - metadata
                      additionalProperties: false
                  total:
                    type: integer
                    minimum: 0
                    maximum: 9007199254740991
                required:
                  - agentResults
                  - signals
                  - total
                additionalProperties: false
        '400':
          description: Bad request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
        '401':
          description: Unauthorized
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
        '500':
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
      security:
        - bearerAuth: []
components:
  schemas:
    DiscoverSignalsInput:
      type: object
      properties:
        agentId:
          type: string
          maxLength: 255
        signalSpec:
          type: string
          maxLength: 5000
        signalIds:
          maxItems: 100
          type: array
          items:
            type: string
            maxLength: 255
        limit:
          default: 20
          type: integer
          maximum: 100
          minimum: 1
        offset:
          default: 0
          type: integer
          minimum: 0
          maximum: 9007199254740991
    ErrorResponse:
      description: Standard error response
      type: object
      properties:
        data:
          type: string
          nullable: true
          enum:
            - null
        error:
          $ref: '#/components/schemas/ApiError'
      required:
        - data
        - error
      additionalProperties: false
    ApiError:
      description: Structured error object
      type: object
      properties:
        code:
          description: Machine-readable error code
          type: string
        message:
          description: Human-readable error message
          type: string
        field:
          description: Field path associated with the error
          type: string
        details:
          description: Additional error context
          type: object
          additionalProperties: {}
      required:
        - code
        - message
      additionalProperties: false
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer
      description: API key or access token

````